// Copyright 2022 Bitcoding

import 'package:flutter/material.dart';
import 'package:get/get.dart';
import 'package:google_applovin_unity_ads/google_applovin_unity_ads.dart';
import 'package:google_applovin_unity_ads_example/AdsModel.dart';
import 'package:google_applovin_unity_ads_example/Model.dart';
import 'package:google_applovin_unity_ads_example/MyController.dart';

class MainScreen extends StatefulWidget {
  const MainScreen({Key? key}) : super(key: key);

  @override
  _MyAppState createState() => _MyAppState();
}

class _MyAppState extends State<MainScreen> {
  Widget _bannerAd = Container(height: 0);
  final nativeAdDistance = 5;

  final String placeholderText = """
      
      Hello This example screen is second screen.
     
      """;

  @override
  void initState() {
    super.initState();
    loadAdsinList();
    showBannerAds(
        size: AdSize.leaderboard,
        onAdLoadedCallback: (bannerAds) => {
              setState(() {
                _bannerAd = bannerAds;
              })
            });
  }

  @override
  void dispose() {
    super.dispose();
    destroyAd();
  }

  @override
  Widget build(BuildContext context) {
    return MaterialApp(
      home: Builder(builder: (BuildContext context) {
        return Scaffold(
          appBar: AppBar(
            title: const Text('Ads example app'),
            actions: <Widget>[
              PopupMenuButton<String>(
                onSelected: (String result) {
                  switch (result) {
                    case 'InterstitialAd':
                      showIntraAds(
                          callback: () => {print("Show Completed true")});
                      break;
                    case 'RewardedAd':
                      showRewardAds(
                          callback: () => {print("Show Completed true")});
                      break;
                    default:
                      throw AssertionError('unexpected button: $result');
                  }
                },
                itemBuilder: (BuildContext context) => <PopupMenuEntry<String>>[
                  const PopupMenuItem<String>(
                    value: 'InterstitialAd',
                    child: Text('InterstitialAd'),
                  ),
                  const PopupMenuItem<String>(
                    value: 'RewardedAd',
                    child: Text('RewardedAd'),
                  )
                ],
              ),
            ],
          ),
          body: SafeArea(
              child: Obx(() => ListView.builder(
                  itemCount: MyController.instance.widgetlist.length,
                  itemBuilder: (context, index) {
                    if (MyController.instance.widgetlist[index] is Model) {
                      return ListTile(
                        title: Text(
                            (MyController.instance.widgetlist[index] as Model)
                                .label),
                      );
                    }

                    if (MyController.instance.widgetlist[index] is AdsModel) {
                      final adsModel =
                          MyController.instance.widgetlist[index] as AdsModel;
                      if (adsModel.getAds() == null) {
                        showMediumNativeAds(onAdLoadedCallback: (_nativeAds) {
                          adsModel.setAds(_nativeAds);
                          MyController.instance.refresh();
                        });
                        return Container(height: 0);
                      } else {
                        return adsModel.getAds();
                      }

                      /*return showBannerAdsGrid(
                          size: adsIndex % 3 == 0 ? AdSize.leaderboard : ( adsIndex % 5 == 0 ? AdSize.mediumRectangle : (adsIndex % 7 == 0 ? AdSize.fullBanner : AdSize.banner))
                      );*/
                    }

                    return Container(height: 0);
                  }))),
          bottomNavigationBar: _bannerAd,
        );
      }),
    );
  }

  loadAdsinList() {
    for (var i = 0; i < 500; i++) {
      MyController.instance.widgetlist
          .add(Model("Default Test \nad sdhakjsh kali\t das"));
      if (MyController.instance.widgetlist.length % nativeAdDistance == 0) {
        MyController.instance.widgetlist.add(AdsModel());
      }
    }
  }
}
